#!/usr/bin/perl -w

use Regexp::Grammars;
use File::Basename;
$filename = $ARGV[0];
local $/ = undef;
open(FILE, $filename);
$content = <FILE>;
close(FILE);
$id = "";
do { 
    no Regexp::Grammars; 
    if ($filename =~ m/^.*?([^\/\\]+)\.([nr])$/) {
        $id = $1;
    }
    else {
        die "Invalid file name.";
    }
};
$path = (fileparse($filename))[1];
if (exists $ARGV[1]) {
    $onlyshow = $ARGV[1];
}
else {
    $onlyshow = "";
}
qr{
    <grammar: notes>
    <token: Paragraph>          <.bls> <lines> <.ble>
    <token: bls>               (?<=\n\n)
    <token: ble>               (?=\n\n)
    <token: partbls>           (?<=\n)
    <token: partble>           (?=\n)
    <token: line>              [^\n]+
    <token: lines>             (<[line]> \n)* <[line]>
    <token: Code>              <.bls> <optionallabel>? <.delimitcode> \n <codelines> \n <.delimitcode> <.ble>
    <token: codeline>          [^\n]*
    <token: codelines>         (<[codeline]> \n)*? <[codeline]>
    <token: delimitcode>       [\<]?===[\>]?

    <token: Label>             \<\< <linklabeltext> \>\>
    <token: optionallabel>     <Label> \n
    <token: linklabeltext>     [^\>]+

}xms;

$code = qr{ <extends: notes> <Code> }xms;
%sourcetexts = ();
$last = "";
while (1) {
    if ($content =~ s/$code//) {
        my $line = join("\n", @{$/{Code}->{codelines}->{codeline}}) . "\n";
        if (exists $/{Code}->{optionallabel}) {
            my $label = $/{Code}->{optionallabel}->{Label}->{linklabeltext};
            if (exists $sourcetexts{$label}) {
                $sourcetexts{$label} .= $line;
                $last = $label;
            }
            else {
                $sourcetexts{$label} = $line;
                $last = $label;
            }
        }
        elsif ($last ne "") {
            $sourcetexts{$last} .= $line;
        }
        else {
            $sourcetexts{$id} = $line;
            $last = $id;
        }
    }
    else {last;}
}
while(($k,$v)=each(%sourcetexts)) {
    open HANDLE, ">",  $path . "/" . $k;
    print HANDLE $v;
    close HANDLE;
    if ($onlyshow eq $k) {
        print $v;
    }
}
